#use "parser.ml"

(*print expr*)
let print expr =
    let rec to_str e =
        let open Printf in
        match e with
        | NUM n -> sprintf "NUM(%d)" n
        | BOOL b -> if b then "BOOL(true)" else "BOOL(false)"
        | VAR v -> sprintf "VAR(%s)" v
        | ADD (a, b) -> sprintf "ADD(%s, %s)" (to_str a) (to_str b)
        | SUB (a, b) -> sprintf "SUB(%s, %s)" (to_str a) (to_str b)
        | EQ  (a, b) -> sprintf "EQ(%s, %s)"  (to_str a) (to_str b)
        | GE  (a, b) -> sprintf "GE(%s, %s)"  (to_str a) (to_str b)
        | AND (a, b) -> sprintf "AND(%s, %s)" (to_str a) (to_str b)
        | OR  (a, b) -> sprintf "OR(%s, %s)"  (to_str a) (to_str b)
        | NOT a      -> sprintf "NOT(%s)"     (to_str a)
        | IF  (c, t, f) -> sprintf "IF(%s, %s, %s)" (to_str c) (to_str t) (to_str f)
        | FUN (v, e) -> sprintf "FUN(%s, %s)"  v (to_str e)
        | CLO (v, e, ev) -> sprintf "CLO(%s, %s, env)" v (to_str e)
        | APP (a, b) -> sprintf "APP(%s, %s)" (to_str a) (to_str b) in

     to_str expr |> (Printf.printf "%s\n")


(*evaluate expr in env*)
let rec eval expr env =
    let dropNUM  = function NUM  n -> n | e -> print e; assert false in
    let dropBOOL = function BOOL b -> b | e -> print e; assert false in
    let dropCLO  = function CLO (v, e, ev) -> (v, e, ev) | e -> print e; assert false in

    (*look up the value of a variable from an environment*)
    (*TODO: implement lookup
        environment is a list of (name, expr) tuples
    *)
    let rec lookup name env =


    match expr with
    (*TODO: evaluate the literal expressions*)
    | BOOL b -> 
    | NUM n  -> 

    (*TODO: evaluate the variable expression*)
    | VAR v  -> 

    (*TODO: implement the primitive operators*)
    | ADD (a, b)   -> 
    | SUB (a, b)   -> 
    | EQ (a, b)    -> 
    | GE (a, b)    -> 
    | AND (a, b)   -> 
    | OR (a, b)    -> 
    | NOT a        -> 

    (*TODO: implement the conditional expression*)
    | IF (c, t, f) -> 

    (*TODO: evaluate the function definition*)
    | FUN (v, e)   -> 

    (*TODO: implement the function application*)
    | APP (f, a)   -> 

    | _ -> assert false
