(*   globals.ml
*)

(*TODO: write the expr type*)    
type expr
    = NUM  of        (*integer*)
    | BOOL of        (*Boolean*)
    | VAR  of        (*variable name*)
    (*arithmetic exprs*)
    | ADD of         (*binary operator*)
    | SUB of  
    (*comparators*)
    | EQ of   
    | GE of 
    (*logical exprs*)
    | AND of  
    | OR  of  
    | NOT of         (*unary operator*)
    (*conditional expr*)
    | IF  of         (*condition, true-expr, false-expr*)
    (*function definition: parameter, body*)
    | FUN of         (*param name and body-expr*)
    (*closure: parameter, body, environment: list of (name, expr) tuples*)
    | CLO of         (*param name, body-expr, env*)
    (*function application: operator, operand*)
    | APP of         (*function and argument*)
